function appendLog(message, css, type) {
  gLogQueue  += "<div type='" + type + "' style='display:" + (type != "error" && gLogErrorMode ? "none" : "block") + "' " + "class='" + css + "'>"
             +     message.replace(/\n/g, '<br/>')
             +  "</div>";
}

function error(message, skipLog) {
  if (!skipLog) {
    appendLog(message, 'error', "error");
  }

  if (gErrorMode) {
    doAlert(message);
  }
}

function doAlert(msg, modal) {
  window.openDialog("chrome://fireftp/content/alert.xul", "alert", "chrome,dialog,resizable,centerscreen" + (modal ? ",modal" : ""), msg);
}

function detailedError(msg, url, linenumber) {
  if (gDebugMode) {
    error('Error message= ' + msg + '\nURL= ' + url + '\nLine Number= ' + linenumber, false);
  }
}

function debug(ex, level) {
  if (gDebugMode) {
    appendLog((level ? level : "Error") + ": " + (ex.stack ? (ex.message + '\n' + ex.stack) : ex), 'error', "debug");
  }
}

function showLog() {
  gLogMode                   = !gLogMode;
  $('cmdlog').collapsed      = !gLogMode;
  $('logsplitter').state     =  gLogMode ? 'open' : 'collapsed';
  gPrefs.setBoolPref("logmode", gLogMode);
}

function filter(display, type) {
  var nodeList = $('cmdlog').contentWindow.document.getElementsByTagName("div");

  for (var x = 0; x < nodeList.length; ++x) {
    if (nodeList.item(x).getAttribute("type") != type) {
      nodeList.item(x).style.display = display;
    }
  }
}

function showOnlyErrors() {
  filter("none",   "error");
}

function showAll() {
  filter("block", "error");
}

function checkLogMouseDown() {
  if ($('cmdlog').collapsed) {
    gLogMode               = true;
    $('cmdlog').collapsed  = false;
    $('logsplitter').state = 'open';
    $('logbutton').checked = true;
    gPrefs.setBoolPref("logmode", gLogMode);
  }
}

function checkLogCollapsed() {
  gLogMode                    = !$('cmdlog').collapsed;
  $('logbutton').checked      = gLogMode;
  gPrefs.setBoolPref("logmode", gLogMode);
}
